mod turtle;

use turtle::{defaults, Turtle};

#[allow(dead_code)]
fn polygon(corners_number: u32, steps_count: u32, output_path: &'static str) {
    let mut turtle = Turtle::new();
    let default_pos = defaults::position();

    let side_length = turtle.step_length() * steps_count;
    let pi = std::f64::consts::PI;
    let circumscribed_circle_radius = side_length as f64 / (2.0 * (pi / corners_number as f64).sin());
    let vertical_offset = circumscribed_circle_radius * (pi / corners_number as f64).cos();

    turtle.set_pos((
        default_pos.0 - (side_length / 2) as i32,
        default_pos.1 - vertical_offset as i32,
    ));
    
    for _ in 0..corners_number {
        turtle.forward_right(steps_count, 360.0 / corners_number as f64);
    }
    turtle.save(output_path).unwrap();
}

fn main() {
    polygon(3, 11, "imgs/polygons/3.png");
    polygon(4, 9, "imgs/polygons/4.png");
    polygon(5, 7, "imgs/polygons/5.png");
    polygon(6, 6, "imgs/polygons/6.png");
    polygon(7, 5, "imgs/polygons/7.png");
    polygon(8, 4, "imgs/polygons/8.png");
    polygon(9, 4, "imgs/polygons/9.png");
    polygon(36, 1, "imgs/polygons/36.png");
}
